/*****************************************************************************
 *
 * FILE:	basilisk.c
 * DESCRIPTION:	Basilisk: simple HTML authoring library
 * DATE:	Mon, Apr  1 2002
 * UPDATE:	Sun, Aug 19 2007
 * AUTHOR:	Kouichi ABE (WALL) / 
 * E-MAIL:	kouichi@MysticWALL.COM
 * URL:		http://www.MysticWALL.COM/
 * COPYRIGHT:	(c) 2002-2007 졿Kouichi ABE (WALL), All rights reserved.
 * $Id: basilisk.c,v 1.4 2007/08/19 16:48:36 kouichi Exp $
 *
 *****************************************************************************/

#if	HAVE_CONFIG_H
#include "config.h"
#endif	/* HAVE_CONFIG_H */

#include <stdio.h>
#include "basilisk.h"
#include "functions.h"

/*****************************************************************************
 *
 *	definition of functions
 *
 *****************************************************************************/

/*
 * FUNCTION NAME:	newHTML
 * DESCRIPTION:		create new HTML object
 * ARGUMENTS:		html doctype
 * RETURN VALUE:	Successful: HTML object, otherwise: NULL
 */
HTML *
newHTML(doctype)
	html_t	doctype;
{
  static bool	once = false;

  if (once) {
    return NULL;
  }
  else {
    once = true;
  }

  switch (doctype) {
    case HTML2:
      return newHTML20();
    case HTML3:
      return newHTML32();
    case HTML4:
    default:
      return NULL;
  }

  return NULL;	/* NOT REACHED */
}
