/*****************************************************************************
 *
 * FILE:	xwrap.c
 * DESCRIPTION:	Cockatrice wrapper functions
 * DATE:	Wed, Jul  2 2003
 * UPDATED:	Sun, Aug 19 2007
 * AUTHOR:	Kouichi ABE (WALL) / 
 * E-MAIL:	kouichi@MysticWALL.COM
 * URL:		http://www.MysticWALL.COM/
 * COPYRIGHT:	(c) 2003-2007 졿Kouichi ABE (WALL), All rights reserved.
 * LICENSE:
 *
 *  Copyright (c) 2003-2007 Kouichi ABE (WALL) <kouichi@MysticWALL.COM>,
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 *
 *   THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 *   ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 *   THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 *   PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
 *   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 *   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 *   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 *   INTERRUPTION)  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 *   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 *   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 *   THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: xwrap.c,v 1.2 2007/08/19 16:48:36 kouichi Exp $
 *
 *****************************************************************************/

#if	HAVE_CONFIG_H
#include "config.h"
#endif	/* HAVE_CONFIG_H */

#if	HAVE_STDLIB_H
#include <stdlib.h>
#endif	/* HAVE_STDLIB_H */
#if	HAVE_STRING_H
#include <string.h>
#endif	/* HAVE_STRING_H */
#include "cockatrice.h"
#include "functions.h"

/******************************************************************************
 *
 *	Functions definition
 *
 *****************************************************************************/

void *
cc_malloc(size)
	size_t	size;
{
  void *	p;

  p = (void *)malloc(size);
  if (p == NULL) {
    cgi_errno = CGIERR_NO_ENOUGH_MEMORY;
  }
  return p;
}

void *
cc_calloc(number, size)
	size_t	number;
	size_t	size;
{
  void *	p;

  p = (void *)calloc(number, size);
  if (p == NULL) {
    cgi_errno = CGIERR_NO_ENOUGH_MEMORY;
  }
  return p;
}

void *
cc_realloc(ptr, size)
	void *	ptr;
	size_t	size;
{
  void *	p;

  p = (void *)realloc(ptr, size);
  if (p == NULL) {
    cgi_errno = CGIERR_NO_ENOUGH_MEMORY;
  }
  return p;
}

char *
cc_strdup(s)
	const char *	s;
{
  char *	p;
  
  if (s == NULL) {
    cgi_errno = CGIERR_INVALID_ARGUMENTS;
    return NULL;
  }

  p = (char *)strdup(s);
  if (p == NULL) {
    cgi_errno = CGIERR_NO_ENOUGH_MEMORY;
  }
  return p;
}
